#include <windows.h>
#include <stdio.h>
#include "resource.h"
#include "LEPCLIB_RT.h"
#define MAX_CONNECT_LENGTH 21
HWND g_hwnd;
#pragma comment(lib, "LEPCLIB_RT2.lib")

#define ANALYSER_SERIALNO ""
#define PCAP_FILENAME "data.pcapng"

BOOL CALLBACK DlgProcMain( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam );
void CallFunction(WPARAM wParam);
void PutResult(const char *str);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
	DialogBox( hInstance, MAKEINTRESOURCE( IDD_LEPCLIB_SAMPLE ), NULL, DlgProcMain );
	return 0;
}

BOOL CALLBACK DlgProcMain( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	g_hwnd = hwnd;
    switch( uMsg ){
    case WM_INITDIALOG:
		SetWindowText(GetDlgItem(hwnd,IDC_SERIAL),ANALYSER_SERIALNO);
		SendMessage(GetDlgItem(hwnd,IDC_SERIAL),EM_SETLIMITTEXT,MAX_CONNECT_LENGTH,0);
        return TRUE;
    case WM_CLOSE:
        EndDialog( hwnd, 0 );
        return TRUE;
    case WM_COMMAND:
		CallFunction(wParam);
        return TRUE;
	}
	return FALSE;
}

void CallFunction(WPARAM wParam)
{
	char tmp[256];
	switch (LOWORD(wParam)) {
	case IDC_LEConnect:
		PutResult("LEConnect:");
		GetWindowText(GetDlgItem(g_hwnd,IDC_SERIAL),tmp,MAX_CONNECT_LENGTH);
		if( LEConnect(tmp) == LE_SUCCESS ){
			PutResult("SUCCESS\r\n");
		} else {
			PutResult("FAIL\r\n");
		}
		return;
	case IDC_LEDisconnect:
		PutResult("LEDisconnect:");
		if( LEDisconnect() == LE_SUCCESS ){
			PutResult("SUCCESS\r\n");
		} else {
			PutResult("FAIL\r\n");
		}
		return;
	case IDC_LEStart:
		PutResult("LEStart:");
		if( LEStartOnline() == LE_SUCCESS ){
			PutResult("SUCCESS\r\n");
		} else {
			PutResult("FAIL\r\n");
		}
        return;
	case IDC_LEStop:
		PutResult("LEStop:");
		if( LEStop() == LE_SUCCESS ){
			PutResult("SUCCESS\r\n");
		} else {
			PutResult("FAIL\r\n");
		}
        return;
	case IDC_LEGetState:
		PutResult("LEGetState:");
		unsigned long state;
		if( LEGetState(&state) == LE_SUCCESS ){
			if( state == STATE_RUN ){
				PutResult("RUNNING:");
			} else {
				PutResult("STOPPED:");
			}
			PutResult("SUCCESS\r\n");
		} else {
			PutResult("FAIL\r\n");
		}
        return;
	case IDC_LEImportPcap:
		PutResult("LEImportPcap:");
		if( LEImportPcap( PCAP_FILENAME ) == LE_SUCCESS ){
			PutResult("\""PCAP_FILENAME"\" was output:");
			PutResult("SUCCESS\r\n");
		} else {
			PutResult("FAIL\r\n");
		}
        return;
	case IDC_LEGetCaptureBuf:
		PutResult("LEGetCaptureBuf:");
		LE_CAPTUREBUF eCaptureBuf;
		if( LEGetCaptureBuf(&eCaptureBuf) == LE_SUCCESS ){
			sprintf_s(tmp,sizeof(tmp),"BUF %d:",eCaptureBuf);
			PutResult(tmp);
			PutResult("SUCCESS\r\n");
		} else {
			PutResult("FAIL\r\n");
		}
		return;
	case IDC_LESetCaptureBuf0:
		PutResult("LESetCaptureBuf:BUF 0:");
		if( LESetCaptureBuf(LE_CAPTUREBUF_0) == LE_SUCCESS ){
			PutResult("SUCCESS\r\n");
		} else {
			PutResult("FAIL\r\n");
		}
		return;
	case IDC_LESetCaptureBuf1:
		PutResult("LESetCaptureBuf:BUF 1:");
		if( LESetCaptureBuf(LE_CAPTUREBUF_1) == LE_SUCCESS ){
			PutResult("SUCCESS\r\n");
		} else {
			PutResult("FAIL\r\n");
		}
		return;
	case IDC_LESetCaptureBuf2:
		PutResult("LESetCaptureBuf:BUF 2:");
		if( LESetCaptureBuf(LE_CAPTUREBUF_2) == LE_SUCCESS ){
			PutResult("SUCCESS\r\n");
		} else {
			PutResult("FAIL\r\n");
		}
		return;
	default:
        return;
	}
}

void PutResult(const char *str)
{
	SendMessage( GetDlgItem(g_hwnd,IDC_RESULT), EM_REPLACESEL, 0, (LPARAM)str );
}

