#include <windows.h>
#include <stdio.h>
#include "resource.h"
#include "LEPCLIB_RT.h"
#define MAX_SERIALNO_LENGTH 256
HWND g_hwnd;

BOOL CALLBACK DlgProcMain( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam );
void CallFunction(WPARAM wParam);
void PutResult(const char *str);
void CBFunc( void *buf, int len );

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
	DialogBox( hInstance, MAKEINTRESOURCE( IDD_LEPCLIB_SAMPLE ), NULL, DlgProcMain );
	return 0;
}

BOOL CALLBACK DlgProcMain( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	g_hwnd = hwnd;
    switch( uMsg ){
    case WM_INITDIALOG:
		SetWindowText(GetDlgItem(hwnd,IDC_SERIAL),"");
        return TRUE;
    case WM_CLOSE:
        EndDialog( hwnd, 0 );
        return TRUE;
    case WM_COMMAND:
		CallFunction(wParam);
        return TRUE;
	}
	return FALSE;
}

void CallFunction(WPARAM wParam)
{
	char tmp[MAX_SERIALNO_LENGTH+1];
	switch (LOWORD(wParam)) {
	case IDC_LEConnect:
		PutResult("LEConnect:");
		GetWindowText(GetDlgItem(g_hwnd,IDC_SERIAL),tmp,MAX_SERIALNO_LENGTH);
		if( LEConnect(tmp) == LE_SUCCESS ){
			PutResult("SUCCESS\r\n");
		} else {
			PutResult("FAIL\r\n");
		}
		return;
	case IDC_LEDisconnect:
		PutResult("LEDisconnect:");
		if( LEDisconnect() == LE_SUCCESS ){
			PutResult("SUCCESS\r\n");
		} else {
			PutResult("FAIL\r\n");
		}
		return;
	case IDC_LEReStartCallBack:
		PutResult("LEReStartCallBack:");
		if( LEReStartCallBack(CBFunc, LE_MONDATA_FORMAT_1) == LE_SUCCESS ){
			PutResult("SUCCESS\r\n");
		} else {
			PutResult("FAIL\r\n");
		}
        return;
	case IDC_LEStop:
		PutResult("LEStop:");
		if( LEStop() == LE_SUCCESS ){
			PutResult("SUCCESS\r\n");
		} else {
			PutResult("FAIL\r\n");
		}

        return;
	default:
        return;
	}
}

void PutResult(const char *str)
{
	SendMessage( GetDlgItem(g_hwnd,IDC_RESULT), EM_REPLACESEL, 0, (LPARAM)str );
}

void CBFunc( void *buf, int len )
{
	LE_MONDATAFORMAT1 *mond = (LE_MONDATAFORMAT1 *)buf;
	int i = 0;
	while(len > 0){
		char tmp[256];
		sprintf(tmp,"SD:%02x status:%02x / RD:%02x status:%02x\r\n",
			mond[i].SD,
			mond[i].statusSD,
			mond[i].RD,
			mond[i].statusRD);
		PutResult(tmp);	
		len -= sizeof(LE_MONDATAFORMAT1);
		i++;
	} 
}
